package com.zjsgfa.project.zjsgfa.service.impl;

import java.util.Collections;
import java.util.List;

import com.zjsgfa.common.utils.DateUtils;
import com.zjsgfa.common.utils.StringUtils;
import com.zjsgfa.project.system.domain.SysUser;
import com.zjsgfa.project.system.mapper.SysUserMapper;
import org.activiti.engine.TaskService;
import org.activiti.engine.task.Task;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.zjsgfa.project.zjsgfa.mapper.BizTodoItemMapper;
import com.zjsgfa.project.zjsgfa.domain.BizTodoItem;
import com.zjsgfa.project.zjsgfa.service.IBizTodoItemService;
import org.springframework.util.CollectionUtils;

/**
 * 待办事项Service业务层处理
 * 
 * @author ruoyi
 * @date 2026-02-11
 */
@Service
public class BizTodoItemServiceImpl implements IBizTodoItemService 
{
    @Autowired
    private BizTodoItemMapper bizTodoItemMapper;

    @Autowired
    private TaskService taskService;

    @Autowired
    private SysUserMapper userMapper;

    /**
     * 查询待办事项
     * 
     * @param id 待办事项主键
     * @return 待办事项
     */
    @Override
    public BizTodoItem selectBizTodoItemById(Long id)
    {
        return bizTodoItemMapper.selectBizTodoItemById(id);
    }

    /**
     * 查询待办事项列表
     * 
     * @param bizTodoItem 待办事项
     * @return 待办事项
     */
    @Override
    public List<BizTodoItem> selectBizTodoItemList(BizTodoItem bizTodoItem)
    {
        return bizTodoItemMapper.selectBizTodoItemList(bizTodoItem);
    }

    /**
     * 新增待办事项
     * 
     * @param bizTodoItem 待办事项
     * @return 结果
     */
    @Override
    public int insertBizTodoItem(BizTodoItem bizTodoItem)
    {
        return bizTodoItemMapper.insertBizTodoItem(bizTodoItem);
    }

    /**
     * 修改待办事项
     * 
     * @param bizTodoItem 待办事项
     * @return 结果
     */
    @Override
    public int updateBizTodoItem(BizTodoItem bizTodoItem)
    {
        return bizTodoItemMapper.updateBizTodoItem(bizTodoItem);
    }

    /**
     * 批量删除待办事项
     * 
     * @param ids 需要删除的待办事项主键
     * @return 结果
     */
    @Override
    public int deleteBizTodoItemByIds(Long[] ids)
    {
        return bizTodoItemMapper.deleteBizTodoItemByIds(ids);
    }

    /**
     * 删除待办事项信息
     * 
     * @param id 待办事项主键
     * @return 结果
     */
    @Override
    public int deleteBizTodoItemById(Long id)
    {
        return bizTodoItemMapper.deleteBizTodoItemById(id);
    }

    @Override
    public int insertTodoItem(String instanceId, String itemName, String itemContent, String module,String comment) {
        BizTodoItem todoItem = new BizTodoItem();
        todoItem.setItemName(itemName);
        todoItem.setItemContent(itemContent);
        todoItem.setIsView("0");
        todoItem.setIsHandle("0");
        todoItem.setModule(module);
        todoItem.setTodoTime(DateUtils.getNowDate());
        List<Task> taskList = taskService.createTaskQuery().processInstanceId(instanceId).active().list();
        int counter = 0;
        for (Task task: taskList) {

            // todoitem 去重
            BizTodoItem bizTodoItem = bizTodoItemMapper.selectTodoItemByTaskId(task.getId());
            if (bizTodoItem != null) continue;

            BizTodoItem newItem = new BizTodoItem();
            BeanUtils.copyProperties(todoItem, newItem);
            newItem.setInstanceId(instanceId);
            newItem.setTaskId(task.getId());
            newItem.setTaskName("task" + task.getTaskDefinitionKey().substring(0, 1).toUpperCase() + task.getTaskDefinitionKey().substring(1));
            newItem.setNodeName(task.getName());
            String assignee = task.getAssignee();
            if (StringUtils.isNotBlank(assignee)) {
                newItem.setTodoUserId(assignee);
                SysUser user = userMapper.selectUserByLoginName(assignee);
                newItem.setTodoUserName(user.getNickName());
                newItem.setComment(comment);
                bizTodoItemMapper.insertBizTodoItem(newItem);
                counter++;
            } else {
                // 查询候选用户组
                List<String> todoUserIdList = bizTodoItemMapper.selectTodoUserListByTaskId(task.getId());
                if (!CollectionUtils.isEmpty(todoUserIdList)) {
                    for (String todoUserId: todoUserIdList) {
                        SysUser todoUser = userMapper.selectUserByLoginName(todoUserId);
                        newItem.setTodoUserId(todoUser.getUserName());
                        newItem.setTodoUserName(todoUser.getNickName());
                        newItem.setComment(comment);
                        bizTodoItemMapper.insertBizTodoItem(newItem);
                        counter++;
                    }
                } else {
                    // 查询候选用户
                    String todoUserId = bizTodoItemMapper.selectTodoUserByTaskId(task.getId());
                    SysUser todoUser = userMapper.selectUserByLoginName(todoUserId);
                    newItem.setTodoUserId(todoUser.getUserName());
                    newItem.setTodoUserName(todoUser.getNickName());
                    newItem.setComment(comment);
                    bizTodoItemMapper.insertBizTodoItem(newItem);
                    counter++;
                }
            }
        }
        return counter;
    }

    @Override
    public List<BizTodoItem> selectBizTodoItemList2(BizTodoItem bizTodoItem) {
        return bizTodoItemMapper.selectBizTodoItemList2(bizTodoItem);
    }

    @Override
    public List<BizTodoItem> selectBizTodoItemListbyinstanceId(BizTodoItem query) {
        return bizTodoItemMapper.selectBizTodoItemListbyinstanceId(query);
    }
}
